       IDENTIFICATION DIVISION.
       PROGRAM-ID. VXML-WR-2-72.
      *
      * OGGETTO: scrive file sequenziale generico
      *
      **** rel 6.2
      * nuovo
      ************ 
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      **** rel 7.2
           SELECT ECFFIL ASSIGN TO DISK
                  ORGANIZATION SEQUENTIAL
                  STATUS SF-ECF.
      ************
       DATA DIVISION.
       FILE SECTION.
      **** rel 7.2
       FD ECFFIL LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-ECF
           RECORD 78 DATA RECORD RF-ECF.
       01  RF-ECF.
           05 ECF-REC PIC X(78).
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
      *
      **** rel 7.2
       01  ID-ECF PIC X(100) VALUE 'comall'.
      ************
       01  COMODI.
      **** rel 7.2
           05 SF-ECF  PIC XX.
      ************
           05 S-TAB    PIC X     VALUE X'09'.
           05 IND      PIC 999   VALUE ZERO.
           05 FLG-OPEN PIC 9     VALUE ZERO.
           05 CAMPO    PIC X(500) VALUE SPACE.
           05 CAMPO2   PIC X(500).
           05 I        PIC 999   VALUE ZERO.
           05 LUNG     PIC 999   VALUE ZERO.
      *
           78 MAX-LIV  VALUE 100.
           05 TAG-LIV  PIC 999   VALUE ZERO.
           05 S-TAG    PIC X(30) OCCURS MAX-LIV.
      *
           05 TTAB       PIC X    VALUE X'09'.
           05 EURO       PIC X    VALUE X'80'.
      **** rel 7.2
           05 ALLFILE    PIC X(200) VALUE SPACE.
           05 TMPPATH    PIC X(100) VALUE SPACE.
           05 COMCNT     PIC 999   VALUE ZERO.
           05 F-UTF8     PIC 9     VALUE ZERO.
           05 I1       PIC 999   VALUE ZERO.
      ************
      *
           COPY 'parwtxt-72'.
           COPY 'parpcns-72'.
      **** rel 7.2
           COPY 'parsx2'.
           COPY 'parg'.
           COPY 'parzf'.
           COPY 'parpxml'.
      *
       01  V-UTF8   PIC X(200) VALUE SPACE.
      *
       01  FILESEM      PIC X(60).
       01  SAVFILE      PIC X(60).
       01  SLEEPSEC     PIC 9(6).
       01  STATUS-CODE  PIC X(2)   COMP-X.
      *---------------------------------------------------------
      *    x routines CBL_CREATE_FILE
      *01  filename          PIC X(45).
       01  W-ACCESS-MODE       PIC X    COMP-X  VALUE 3.
       01  W-DENY-MODE         PIC X    COMP-X  VALUE 3.
       01  W-DEVICE            PIC X    COMP-X  VALUE 0.
       01  W-FILE-HANDLE       PIC X(4).
      *---------------------------------------------------------
      * Parametri CBL_CHECK_EXIST_FILE
      *01  file-name          PIC X(60).
       01  FILE-DETAILS.
           05 FILE-SIZE       PIC X(8) COMP-X.
           05 FILE-DATE.
              10 F-DAY        PIC X  COMP-X.
              10 F-MONTH      PIC X  COMP-X.
              10 F-YEAR       PIC X(2) COMP-X.
           05 FILE-TIME.
              10 F-HOURS      PIC X COMP-X.
              10 F-MINUTES    PIC X COMP-X.
              10 F-SECONDS    PIC X COMP-X.
              10 F-HINDREDTHS PIC X COMP-X.
      *---------------------------------------------------------
      * Parametri X"91" function 69 (scan dir)
       01  RESULT.
           05 F-ERROR      PIC X     COMP-X.
           05 F-HANDLE     PIC X(2)  COMP-X.
           05 F-ATTROUT    PIC X     COMP-X.
           05 F-TIME       PIC X(2)  COMP-X.
           05 F-DATE       PIC X(2)  COMP-X.
           05 F-SIZE       PIC X(4)  COMP-X.
           05 F-FILEOUT    PIC X(60).
       01  FUNCTION-CODE   PIC X     COMP-X VALUE 69.
       01  PARAMETER.
           05 F-ACTION     PIC X     COMP-X.
           05 F-ATTRIN     PIC X     COMP-X.
           05 F-FILEIN     PIC X(60).
      *---------------------------------------------------------
      * Parametri CBL_COPY_FILE, CBL_DELETE_FILE, CBL_RENAME_FILE
       01  FILE-INP            PIC X(100).
       01  FILE-OUT            PIC X(100).
      *01  STATUS-CODE         PIC X(2)   COMP-X.
      *---------------------------------------------------------
      ************
       LINKAGE SECTION.
           COPY 'parwxml-2-72'.
      *
       PROCEDURE DIVISION USING PARWXML.
      *
       INIZIO.
      *
           IF PWXM-NOMEFX = SPACE GO TO FINE.
      *
           IF FLG-OPEN = ZERO
              PERFORM APRI-FILE.

           IF PWXM-FUN = 'E' OR '-' GO TO LP-CHIUDI.

           MOVE ZERO TO PCNS-PARAM.
           MOVE SPACE TO PCNS-STR CAMPO.
      *
           IF PWXM-TIPO = ZERO AND PWXM-CAMPO NOT = SPACE
              MOVE ZERO TO PCNS-FLGN
              MOVE PWXM-CAMPO TO PCNS-CAMPO
              IF PWXM-FUN NOT = 'C'
                 PERFORM VER-CAR THRU EX-VER-CAR
              END-IF
              GO TO LP-CAMPO.
           IF PWXM-TIPO = 1
              MOVE 1 TO PCNS-FLGN
              MOVE 3 TO PCNS-FLGM
              MOVE 'n' TO PCNS-SEGNO
              MOVE PWXM-NUM TO PCNS-NUM
      **** rel 6.3
              MOVE PWXM-NDEC TO PCNS-NDEC
      ************
              GO TO LP-CAMPO.
      **** rel 6.3
      *    IF PWXM-TIPO = 2
           IF PWXM-TIPO = 2 OR 3
      ************
              MOVE 2 TO PCNS-FLGN
              MOVE PWXM-DATA TO PCNS-DATA
              MOVE 10 TO PCNS-FLGD
              GO TO LP-CAMPO.
      **** rel 7.2
           IF PWXM-TIPO = 6
              MOVE PWXM-CAMPO TO ALLFILE  
              GO TO LP-CAMPO.
      ************
           GO TO NO-CAMPO.
       LP-CAMPO.
           CALL 'concstr-72' USING PARPCNS.
      **** rel 6.3
           IF PWXM-TIPO = 3
              IF PWXM-TIME = SPACE
                 MOVE ZERO TO PWXM-TIME
              END-IF
              MOVE ZERO TO PCNS-FLGN
              MOVE 1 TO PCNS-FLGB
              STRING "T" PWXM-TIME(1:2)
                     ":" PWXM-TIME(3:2)
                     ":" PWXM-TIME(5:2)
                     INTO PCNS-CAMPO
              CALL 'concstr-72' USING PARPCNS.
      ************
           MOVE PCNS-STR TO CAMPO.
           MOVE SPACE TO PCNS-STR.
       NO-CAMPO.
           IF PWXM-FUN = 'C'
              PERFORM CREA-COMM THRU EX-CREA-COMM
              GO TO LP-FINE.

           PERFORM CREA-TAG THRU EX-CREA-TAG.

      **** rel 7.2
           IF ALLFILE NOT = SPACE AND PWXM-TIPO = 6
              PERFORM ALLEGATO THRU EX-ALLEGATO.
      ************
           IF CAMPO NOT = SPACE
              MOVE CAMPO TO PWTX-CAMPO
              MOVE 'W'   TO PWTX-FUN
              CALL 'vtxt-wr-72' USING PARWTXT.

       LP-CHIUDI.
           IF PWXM-FUN = '+'
              MOVE 'C' TO PWTX-FUN
              CALL 'vtxt-wr-72' USING PARWTXT
           ELSE
      **** rel 6.3
              IF TAG-LIV > ZERO
      ************
              PERFORM CHIUDI-TAG THRU EX-CHIUDI-TAG.

           IF PWXM-FUN NOT = 'E' GO TO LP-FINE.

           IF TAG-LIV > ZERO GO TO LP-CHIUDI.

           MOVE 'E' TO PWTX-FUN.
           CALL 'vtxt-wr-72' USING PARWTXT.
      **** rel 7.2
           MOVE PWTX-NOMEFX TO FILE-INP.
           MOVE PWXM-NOMEFX TO FILE-OUT.
           CALL "CBL_RENAME_FILE" USING FILE-INP
                                        FILE-OUT
                               RETURNING STATUS-CODE.
      ************
      **** rel 6.3
           MOVE ZERO TO FLG-OPEN.
      ************

       LP-FINE.
           MOVE SPACE TO PWXM-FUN.
           MOVE SPACE TO PWXM-TAG.
      **** rel 7.1
      *    MOVE SPACE TO PWXM-NATTR.
      *    MOVE SPACE TO PWXM-VATTR.
           MOVE SPACE TO PWXM-ATTR.
      ************
           MOVE SPACE TO PWXM-CAMPO.
           MOVE ZERO  TO PWXM-NUM.
      **** rel 6.3
           MOVE ZERO  TO PWXM-NDEC.
           MOVE ZERO  TO PWXM-TIME.
      ************
           MOVE ZERO  TO PWXM-DATA.
           MOVE ZERO  TO PWXM-TIPO.
      **** rel 7.2
           CLOSE ECFFIL.
      ************
           GO TO FINE.
      * 
       FINE.
           EXIT PROGRAM.
      *------------------
       APRI-FILE.
           MOVE ZERO TO PCNS-PARAM.

      **** rel 7.2
      *    MOVE PWXM-NOMEFX TO PWTX-NOMEFX.
           MOVE SPACE TO PWTX-NOMEFX.
           MOVE 1 TO IND.
           PERFORM UNTIL PWXM-NOMEFX(IND:) = SPACE OR IND = 100
              ADD 1 TO IND.
           STRING PWXM-NOMEFX(1:IND - 1) '_TMP' INTO PWTX-NOMEFX.
      ************
           MOVE ZERO TO PWTX-LEN.
           MOVE SPACE TO PWTX-SEP.
           MOVE ZERO  TO PWTX-EOR.
           MOVE '<?xml version="1.0" encoding="ISO-8859-1"?>'
                TO PWTX-CAMPO.
      **** rel 7.2
           MOVE ZERO TO F-UTF8.
           IF PWXM-ENCODE = 'U' or 'u'
              MOVE 1 TO F-UTF8
              MOVE '<?xml version="1.0" encoding="UTF-8"?>'
                   TO PWTX-CAMPO.
      ************
           MOVE 'w'   TO PWTX-FUN.
           CALL 'vtxt-wr-72' USING PARWTXT.
      *
           MOVE 'C'   TO PWTX-FUN.
           CALL 'vtxt-wr-72' USING PARWTXT.
      *
           MOVE 1 TO FLG-OPEN.
           MOVE ZERO TO TAG-LIV.
      *------------------
       CREA-TAG.
      *
.          IF TAG-LIV NOT < MAX-LIV GO TO EX-CREA-TAG.

           ADD 1 TO TAG-LIV.

           MOVE ZERO TO PCNS-PARAM.
           MOVE SPACE TO PCNS-STR.
      *
           PERFORM ADD-TAB.
      *
           MOVE '<' TO PCNS-CAMPO.
           CALL 'concstr-72' USING PARPCNS.
      *
           MOVE PCNS-ULT TO IND.
           MOVE 1 TO PCNS-FLGB.
           IF PWXM-TAG = SPACE
              MOVE 'TAG-' TO PCNS-CAMPO
              CALL 'concstr-72' USING PARPCNS
      *
              MOVE TAG-LIV TO PCNS-NUM
              MOVE 1 TO PCNS-FLGB
              MOVE 1 TO PCNS-FLGN
              MOVE 'N' TO PCNS-SEGNO
              MOVE 1 TO PCNS-FLGM
              CALL 'concstr-72' USING PARPCNS
           ELSE
              MOVE PWXM-TAG TO PCNS-CAMPO.
           CALL 'concstr-72' USING PARPCNS.

           MOVE PCNS-STR(IND + 1:) TO S-TAG(TAG-LIV).
      *
      **** rel 7.1
      *    IF PWXM-NATTR NOT = SPACE
      *       MOVE ZERO TO PCNS-FLGB
      *       MOVE PWXM-NATTR TO PCNS-CAMPO
      *       CALL 'concstr-72' USING PARPCNS
      *
      *       MOVE 1 TO PCNS-FLGB
      *       MOVE '=' TO PCNS-CAMPO
      *       CALL 'concstr-72' USING PARPCNS
      *
      *       MOVE 1 TO PCNS-FLGB
      *       MOVE '"' TO PCNS-CAMPO
      *       CALL 'concstr-72' USING PARPCNS
      *
      *       MOVE 1 TO PCNS-FLGB
      *       MOVE PWXM-VATTR TO PCNS-CAMPO
      *       PERFORM VER-CAR THRU EX-VER-CAR
      *       CALL 'concstr-72' USING PARPCNS
      *
      *       MOVE 1 TO PCNS-FLGB
      *       MOVE '"' TO PCNS-CAMPO
      *       CALL 'concstr-72' USING PARPCNS.
           IF PWXM-NATTR(1) NOT = SPACE
              MOVE 1 TO IND
              PERFORM UNTIL IND > 10 OR PWXM-NATTR(IND) = SPACE
                 MOVE ZERO TO PCNS-FLGB
      *
                 MOVE PWXM-NATTR(IND) TO PCNS-CAMPO
                 CALL 'concstr-72' USING PARPCNS
      *
                 MOVE 1 TO PCNS-FLGB
                 MOVE '=' TO PCNS-CAMPO
                 CALL 'concstr-72' USING PARPCNS
      *
                 MOVE 1 TO PCNS-FLGB
                 MOVE '"' TO PCNS-CAMPO
                 CALL 'concstr-72' USING PARPCNS
      *
                 MOVE 1 TO PCNS-FLGB
                 MOVE PWXM-VATTR(IND) TO PCNS-CAMPO
                 PERFORM VER-CAR THRU EX-VER-CAR
                 CALL 'concstr-72' USING PARPCNS
      *
                 MOVE 1 TO PCNS-FLGB
                 MOVE '"' TO PCNS-CAMPO
                 CALL 'concstr-72' USING PARPCNS
      *
                 ADD 1 TO IND
             END-PERFORM.
      ************
      *
      **** rel 7.2
      *    IF CAMPO NOT = SPACE OR PWXM-FUN = '+'
           IF CAMPO NOT = SPACE OR PWXM-FUN = '+' OR PWXM-TIPO = 6
      ************
              MOVE 1 TO PCNS-FLGB
              MOVE '>' TO PCNS-CAMPO
              CALL 'concstr-72' USING PARPCNS
           ELSE
              MOVE SPACE TO S-TAG(TAG-LIV).
      *
           MOVE PCNS-STR TO PWTX-CAMPO.
           MOVE 'W'   TO PWTX-FUN.
           CALL 'vtxt-wr-72' USING PARWTXT.
           MOVE SPACE TO PCNS-STR.
      *
       EX-CREA-TAG.
           EXIT.
      *------------------
       CHIUDI-TAG.
           MOVE ZERO TO PCNS-PARAM.
           MOVE SPACE TO PCNS-STR.
      *
           IF PWXM-FUN = '-' OR 'E'
              PERFORM ADD-TAB.
      *
           IF S-TAG(TAG-LIV) NOT = SPACE
              MOVE '</' TO PCNS-CAMPO
              CALL 'concstr-72' USING PARPCNS
      *
              MOVE 1 TO PCNS-FLGB
              MOVE S-TAG(TAG-LIV) TO PCNS-CAMPO
              CALL 'concstr-72' USING PARPCNS
           ELSE
              MOVE ZERO TO PCNS-FLGB
              MOVE 1 TO PCNS-FLGS
              MOVE ' /' TO PCNS-CAMPO
              CALL 'concstr-72' USING PARPCNS.
      *
           MOVE 1 TO PCNS-FLGB.
           MOVE '>' TO PCNS-CAMPO.
           CALL 'concstr-72' USING PARPCNS.
      *
           MOVE PCNS-STR TO PWTX-CAMPO.
           MOVE 'C'   TO PWTX-FUN.
           CALL 'vtxt-wr-72' USING PARWTXT.
           MOVE SPACE TO PCNS-STR.

           SUBTRACT 1 FROM TAG-LIV.
      *
       EX-CHIUDI-TAG.
           EXIT.
      *------------------
       VER-CAR.
           MOVE LENGTH OF PCNS-CAMPO TO LUNG.
           MOVE 1 TO I.
           MOVE SPACE TO CAMPO2.
           PERFORM UNTIL PCNS-CAMPO(I:) = SPACE OR I > LUNG
      **** rel 7.2
              MOVE PWXM-TIP TO PXML-TIP
              MOVE PCNS-CAMPO(I:1) TO PXML-IN
              CALL 'vrpxml' USING PARPXML
              IF PXML-ERR = ZERO AND
                 PXML-LL > ZERO
                    IF NOT (PXML-OUT = '<del>' OR '<DEL>')
      *
                       MOVE PCNS-CAMPO TO CAMPO2
                       STRING CAMPO2(1: I - 1)
                              PXML-OUT(1:PXML-LL)
                              CAMPO2(I + 1:)
                              DELIMITED SIZE INTO PCNS-CAMPO
                       MOVE SPACE TO CAMPO2
                       COMPUTE LUNG = LUNG + PXML-LL - 1
                       COMPUTE I = I + PXML-LL - 1
      *
                   ELSE   *> cancella carattere
      *
                       MOVE PCNS-CAMPO TO CAMPO2
                       STRING CAMPO2(1: I - 1)
                              CAMPO2(I + 1:)
                              DELIMITED SIZE INTO PCNS-CAMPO
                       MOVE SPACE TO CAMPO2
                       COMPUTE LUNG = LUNG - 1
                       COMPUTE I = I - 1
                   END-IF
              ELSE
                 IF F-UTF8 NOT = ZERO AND
                    PCNS-CAMPO(I:1) NOT = SPACE
                       MOVE PCNS-CAMPO(I:1) TO V-UTF8
                       CALL 'asc2utf8-72' USING V-UTF8
                       MOVE 1 TO I1
                       PERFORM UNTIL V-UTF8(I1:) = SPACE
                          ADD 1 TO I1
                       END-PERFORM
                       SUBTRACT 1 FROM I1
                       MOVE PCNS-CAMPO TO CAMPO2
                          STRING CAMPO2(1: I - 1)
                              V-UTF8(1:I1)
                              CAMPO2(I + 1:)
                              DELIMITED SIZE INTO PCNS-CAMPO
                       MOVE SPACE TO CAMPO2
                       SUBTRACT 1 FROM I1
                       ADD I1 TO I LUNG
                 END-IF
              END-IF
      *
              ADD 1 TO I.
      ************
       EX-VER-CAR.
           EXIT.
      *------------------
       ADD-TAB.
           MOVE 1 TO IND.
           PERFORM UNTIL IND NOT < TAG-LIV
              MOVE S-TAB TO PCNS-CAMPO
              CALL 'concstr-72' USING PARPCNS
              ADD 1 TO IND
              MOVE 1 TO PCNS-FLGB.
       EX-ADD-TAB.
           EXIT.
      *------------------
       CREA-COMM.
      *
           MOVE ZERO TO PCNS-PARAM.
           MOVE SPACE TO PCNS-STR.
      *
           PERFORM ADD-TAB.
      *
           MOVE '<!-- ' TO PCNS-CAMPO.
           CALL 'concstr-72' USING PARPCNS.
      *
           MOVE CAMPO TO PCNS-CAMPO.
           CALL 'concstr-72' USING PARPCNS.
      *
           MOVE ZERO TO PCNS-FLGB.
           MOVE '-->' TO PCNS-CAMPO.
           CALL 'concstr-72' USING PARPCNS.
      *
           MOVE PCNS-STR TO PWTX-CAMPO.
           MOVE 'C'   TO PWTX-FUN.
           CALL 'vtxt-wr-72' USING PARWTXT.
           MOVE SPACE TO PCNS-STR.
      *
       EX-CREA-COMM.
           EXIT.
      *------------------
      **** rel 7.2
       ALLEGATO.
           MOVE 'GRTMP' TO G-VAR.
           CALL 'rgenv' USING PARG.
           IF G-RET = SPACE
              MOVE 'c:\tmp' TO G-RET.
           MOVE G-RET TO TMPPATH.
      *
           MOVE SPACE TO FILESEM.
           STRING TMPPATH '\_ALLE.SEM' DELIMITED SPACE
                  INTO FILESEM.
      *
           MOVE SPACE TO FILE-OUT.
           STRING TMPPATH '\comall.txt.b64' 
                  DELIMITED SPACE INTO FILE-OUT.
           CALL 'CBL_DELETE_FILE' USING FILE-OUT.
      *
           CALL 'CBL_DELETE_FILE' USING FILESEM.
      *
           CALL "CBL_CREATE_FILE" USING FILESEM
                                        W-ACCESS-MODE
                                        W-DENY-MODE
                                        W-DEVICE
                                        W-FILE-HANDLE.
      *
           CALL "CBL_CLOSE_FILE" USING W-FILE-HANDLE.
           MOVE SPACE TO FILE-INP FILE-OUT.
      * sposto il file da elaborare sotto TMP
           MOVE ALLFILE              TO FILE-INP.
           STRING TMPPATH '\comall.txt' DELIMITED SPACE INTO FILE-OUT.
           CALL "CBL_COPY_FILE" USING FILE-INP FILE-OUT 
                                RETURNING STATUS-CODE.
           IF STATUS-CODE NOT = ZERO
              GO TO EX-ALLEGATO.
           MOVE FILE-OUT TO ALLFILE.
      *
           MOVE 'm' TO SX-MOD.
           MOVE SPACE TO SX-CMD.
           STRING 'encb64.bat ' DELIMITED SIZE
                  ALLFILE DELIMITED SIZE
                  INTO SX-CMD.
           CALL 'vrshx2' USING PARSX.
      *
      * Attesa eliminazione file FILESEM
           MOVE 50 TO COMCNT.
       LPCNT1.
           SUBTRACT 1 FROM COMCNT.

           CALL "CBL_CHECK_FILE_EXIST" USING FILESEM
                                             FILE-DETAILS
                               RETURNING STATUS-CODE.
           IF STATUS-CODE NOT = ZERO GO TO OK-CNV1.

      *
           MOVE 5 TO SLEEPSEC.
           CALL 'vrsleep' USING SLEEPSEC.
           GO TO LPCNT1.
       OK-CNV1.
      *
           CALL 'CBL_DELETE_FILE' USING ALLFILE.
      *
           STRING ALLFILE '.b64' DELIMITED SPACE INTO ID-ECF.
           OPEN INPUT ECFFIL.
       INIZIO-LETTURA.
           READ ECFFIL AT END GO TO FINE-LETTURA.
           MOVE SPACE   TO PWTX-CAMPO.
           MOVE ECF-REC  TO PWTX-CAMPO.
           MOVE SPACE   TO PWTX-SEP.
           MOVE 9       TO PWTX-EOR.
           MOVE 'W'     TO PWTX-FUN.
           CALL 'vtxt-wr-72' USING PARWTXT.
      *
           MOVE SPACE TO RF-ECF.
      *
           GO TO INIZIO-LETTURA.
       FINE-LETTURA.
           CLOSE ECFFIL.
           MOVE ZERO  TO PWTX-EOR.
      *
           STRING ALLFILE '.b64' DELIMITED SPACE INTO ALLFILE.
           CALL 'CBL_DELETE_FILE' USING ALLFILE.
      *
       EX-ALLEGATO.
           EXIT.
      *------------------
      ************
