       IDENTIFICATION DIVISION.
       PROGRAM-ID. VFATX10.
      *
      *    Interfaccia FATTUR per list box
      *
      **** rel 7.2
      * Nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gribctsl'.
           COPY 'griclfsl'.
           COPY 'gritabsl'.
           COPY 'grifatsl'.
           COPY 'griaftsl'.
           COPY 'grispssl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'gribct'.
           COPY 'griclf'.
           COPY 'gritab'.
           COPY 'grifat'.
           COPY 'griaft'.
           COPY 'grisps'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parper'.
           COPY 'parlpd'.
           COPY 'parxcd'.
           COPY 'parpint'.
           COPY 'parrb'.
           COPY 'parmb'.
      *
           COPY 'zoom-v'.
      *
       01  ID-BCT  PIC X(15) VALUE 'bolcte'.
       01  ID-CLF  PIC X(15) VALUE 'anaclf'.
       01  ID-TAB  PIC X(15) VALUE 'tabell'.
       01  ID-SPS  PIC X(15) VALUE 'spesog'.
       01  ID-FAT.
           05 FILLER PIC X(6) VALUE 'fattur'.
           05 FATTIV PIC X    VALUE SPACE.
           05 FILLER PIC X(8) VALUE SPACE.
       01  ID-AFT  PIC X(15) VALUE 'appfat'.
       01  SF-BCT  PIC XX.
       01  SF-CLF  PIC XX.
       01  SF-TAB  PIC XX.
       01  SF-FAT  PIC XX.
       01  SF-AFT  PIC XX.
       01  SF-SPS  PIC XX.
       01  AREE.
           05 NPGMLVIEW PIC X(10) VALUE 'vfatx10l'.
           05 NPGMZOOM  PIC X(10) VALUE 'vfatx10'.
           05 TABKTDOC  PIC 9(5)  OCCURS 99999.
           05 TABKNFAT  PIC 9(5)  OCCURS 99999.
           05 TKTDOC    PIC 9     OCCURS 99999.
           05 TKTMODU   PIC 9     OCCURS 99999.
           05 KRIFER    PIC X(30).
           05 CHECK     PIC 9.
           05 COMFT     PIC 9(5).
           05 COMTIPO   PIC X(4).
      *
           05 MCLI    PIC 99.
           05 MFOR    PIC 99.
           05 CODICE.
              10 MAS PIC 99.
              10 COD PIC 9(5).
      *
           05 XNUFAT.
              10 NUFAT   PIC 9(5) COMP-3.
      *
           05 DAT1      PIC 9(5).
           05 DAT2      PIC 9(5).
      *
      * Parametri CBL_CHECK_EXIST_FILE
       01  FILE-NAME          PIC X(60).
       01  FILE-DETAILS.
           05 FILE-SIZE       PIC X(8) COMP-X.
           05 FILE-DATE.
              10 F-DAY        PIC X  COMP-X.
              10 F-MONTH      PIC X  COMP-X.
              10 F-YEAR       PIC X(2) COMP-X.
           05 FILE-TIME.
              10 F-HOURS      PIC X COMP-X.
              10 F-MINUTES    PIC X COMP-X.
              10 F-SECONDS    PIC X COMP-X.
              10 F-HINDREDTHS PIC X COMP-X.
       01  STATUS-CODE        PIC X(2)   COMP-X.
      *---------------------------------------------------------
           COPY 'vfatx10.cpy'.
      *
       LINKAGE SECTION.
           COPY 'grifatrx'
           REPLACING GS-FAT-AZI    BY GS-AZI
                     GS-FAT-FUN    BY GS-FUN
                     GS-FAT-IDX    BY GS-IDX
                     GS-FAT-SV     BY GS-SV 
                     GS-FAT-SEL    BY GS-SEL
                     RX-FAT-FUN    BY RX-FUN
                     RX-FAT-ST     BY RX-ST
                     RX-FAT-POS    BY RX-POS
                     RX-FAT-NUM    BY RX-NUM
                     RX-FAT-LETTI  BY RX-LETTI
                     RX-FAT-EOF    BY RX-EOF
                     RX-FAT-RG-EOF BY RX-RG-EOF
                     RX-FAT-CAMPO  BY RX-CAMPO.
      *
       01  IF-MESS    PIC X(204).
           COPY 'lview.cpy'.
       PROCEDURE DIVISION USING GS-FAT-SHARED
                                RX-FAT-CTRL
                                IF-MESS
                                DATA-BLOCK.
           COPY 'declxer1'.
           COPY 'dclbct'.
           COPY 'dclclf'.
           COPY 'dcltab'.
           COPY 'dclfat'.
           COPY 'dclaft'.
           COPY 'dclsps'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RX-ST RX-RG-EOF.
           MOVE SPACE TO IF-MESS.
           IF SWINI = ZERO PERFORM PGM-INI THRU EX-PGM-INI.
           MOVE RX-FUN TO FUN.
           MOVE RX-NUM TO NUM.
           MOVE ZERO   TO RX-POS.
           MOVE GS-IDX TO IDX.
      *
      *> parte con il caricamente dello zoom
           COPY 'zoom-i'.
           IF NOT (IDX = 1 OR 2) MOVE 1 TO IDX.
      *
           MOVE GS-FAT-CATT TO FATTIV.
           IF FATTIV = '0' MOVE SPACE TO FATTIV.
           PERFORM CHECK-FATTUR THRU EX-CHECK-FATTUR.
           IF CHECK = 1
              MOVE 'Fatture inesistenti su attivit' TO F-MES1
              MOVE 'selezionata.                   ' TO F-MES2
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO FINE.
           OPEN INPUT BOLCTE
                      FATTUR
                      APPFAT
                      SPESOG
                      ANACLF.
           CALL 'vrpint' USING PARPINT.
       INI00.
           MOVE ZERO TO EOF LETTI.
           PERFORM MOVE-KEY THRU EX-MOVE-KEY.
           IF IDX = 1 PERFORM START-IDX1.
      *    IF IDX = 2 PERFORM START-IDX2.
           IF EOF > ZERO GO TO ENDATI.
      *
      * cerca primo record nel range richiesto
       CERCA.
           PERFORM READ-N-P.
           IF EOF > ZERO GO TO ENDATI.
           IF FUN = 'F' OR 'L' OR 'C' GO TO CARBUF.
           IF IDX = 1 GO TO CER90.
      *    ( controlla tramite chiave primaria se il record letto da
      *      secondario e' quello richiesto )
           IF KEYBC NOT = KRIFER GO TO CERCA.
      * 
           COPY 'zoom-r'.
      *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RX-ST.
       FINE.
           CLOSE BOLCTE
                 FATTUR
                 APPFAT
                 SPESOG
                 ANACLF.
       ESCI.
           IF FUN = 'X' OR 'N' OR 'P'
              IF RX-POS NOT = ZERO
                 MOVE TABKTDOC(RX-POS) TO GS-FAT-COD-TDOC
                 MOVE TABKNFAT(RX-POS) TO GS-FAT-COD-NFAT
                 MOVE TKTDOC(RX-POS)  TO GS-FAT-TDOC
                 MOVE TKTMODU(RX-POS) TO GS-FAT-TMODU.
      *
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RX-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'gribcter'.
           COPY 'griclfer'.
           COPY 'gritaber'.
           COPY 'griafter'.
           COPY 'grifater'.
           COPY 'grispser'.
           COPY 'grixxxer'.
      *--------
       PGM-INI.
           OPEN INPUT TABELL.
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MFOR TO MFOR.
           MOVE T01-MCLI TO MCLI.
           CLOSE TABELL.
      *
           MOVE 1 TO SWINI.
       EX-PGM-INI.
           EXIT.
      *------------------
       START-IDX1.
           IF FUN = 'T' OR 'L'
              START FATTUR KEY <= KEYFT INVALID MOVE 1 TO EOF
           ELSE
              START FATTUR KEY >= KEYFT INVALID MOVE 3 TO EOF.
      *------------------
      *START-IDX2.
      *    IF FUN = 'T' OR 'L'
      *       START BOLCTE KEY <= SKEYBC1 INVALID MOVE 1 TO EOF
      *    ELSE
      *       START BOLCTE KEY >= SKEYBC1 INVALID MOVE 3 TO EOF.
      *------------------
       READ-N-P.
           IF FUN = 'T' OR 'L'
              MOVE 'P' TO LVITEM-DOVE
              READ FATTUR PREVIOUS AT END MOVE 1 TO EOF
           ELSE
              MOVE 'D' TO LVITEM-DOVE
              READ FATTUR NEXT AT END MOVE 3 TO EOF.
      *
           MOVE KFT-AZI  TO KAFT-AZI.
           MOVE KFT-TDOC TO KAFT-TDOC.
           MOVE KFT-NUM  TO KAFT-NUM.
           MOVE FAT-CATT TO KAFT-CATT.
           READ APPFAT INVALID
                PERFORM AZZ-AFT THRU EX-AZZ-AFT.
      *
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-NBOL(1) TO KBC-BOL.
           MOVE RB-TNUM(1) TO KBC-NUM.
           READ BOLCTE.
      *
      *------------------
       MOVE-KEY.
           MOVE LOW-VALUE TO KEYFT.
           IF FUN = 'L' MOVE HIGH-VALUE TO KEYFT.
      * caricamento campi chiave fissi
           MOVE GS-AZI  TO KFT-AZI.
      * ---
           IF FUN = 'C'        GO TO MOVE-KEY-C.
           IF FUN = 'B' OR 'T' GO TO MOVE-KEY-N-P.
           GO TO EX-MOVE-KEY.
       MOVE-KEY-C.
           IF IDX = 1 MOVE GS-FAT-VAL-1-TDOC TO KFT-TDOC
                      MOVE GS-FAT-VAL-1-NFAT TO KFT-NUM.
           GO TO EX-MOVE-KEY.
       MOVE-KEY-N-P.
           MOVE TABKTDOC(RIGRIF) TO KFT-TDOC.
           MOVE TABKNFAT(RIGRIF) TO KFT-NUM.
           MOVE KEYFT TO KRIFER.
           IF IDX = 1 GO TO EX-MOVE-KEY.
      * acquisizione chiavi secondarie tramite lettura da primario
       EX-MOVE-KEY.
           EXIT.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-FAT = LOW-VALUE GO TO EX-TEST-EOL.
           IF IDX > 1 GO TO TEST-EOL-IDX2.
           IF KFT-AZI = GS-AZI  GO TO EX-TEST-EOL.
           IF FUN = 'T' OR 'L'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       TEST-EOL-IDX2.
       EX-TEST-EOL.
           EXIT.
      *------------------
       MOVE-REC.
           IF RF-FAT = LOW-VALUE GO TO EX-MOVE-REC.
      *
      *    ( inserire qui controlli se ci sono records
      *      da escludere prima di incontrare BOF/EOF:
      *      per skip record GO TO EX-MOVE-REC )
      *
      *> filtri
           PERFORM CONTROLLA-FILTRI THRU EX-CONTROLLA-FILTRI.
           IF FLGOK = ZERO
              IF FUN = 'U' 
                 PERFORM DELETE-ITEM THRU EX-DELETE-ITEM
                 GO TO MOVE-END
              ELSE
                 GO TO EX-MOVE-REC.
      *
           MOVE LOW-VALUE  TO RIG1.
      *
           MOVE '08' TO LVDATA-ICON.
      *
           MOVE AFT-XML   TO XML1.
           MOVE KFT-TDOC  TO TDOC1.
           MOVE KFT-NUM   TO COD1.
           MOVE FAT-CDCLI TO CODCL.
      *
           MOVE KBC-AZI   TO KCF-AZI.
           MOVE FAT-CDCLI TO COD.
           IF BCT-TDOC = 6 OR 7 MOVE MFOR TO MAS
              ELSE MOVE MCLI TO MAS.
           MOVE CODICE TO KCF-COD.
           READ ANACLF INVALID MOVE ALL '*' TO CLF-RGS.
           MOVE KEYCF  TO KEYSPS.
           READ SPESOG INVALID
                MOVE SPACE TO RF-SPS
                MOVE ZERO  TO SPS-FADTORD
                MOVE SPACE TO SPS-CODICEDEST.
      *
           MOVE CLF-RGS  TO RGSOC.
           MOVE CLF-RGS2 TO RGSOC2.
           MOVE 2 TO TIPOP1.
           MOVE FAT-DATA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DTBOL.
      *
           MOVE BCT-ZONA   TO ZONA.
           MOVE FAT-CDAGE   TO CDAGE.
           MOVE BCT-PROVV  TO PROVV.
           MOVE BCT-VALUT  TO VALUT.
           MOVE BCT-CAUS   TO CAUS.
           MOVE BCT-CAUC   TO CAUC.
      *
           MOVE FAT-CDPAG   TO CPAG.
           MOVE FAT-SCBAS  TO SCBAS.
           MOVE FAT-CDBAN   TO CDBAN.
           MOVE FAT-CDESE  TO ESIVA.
           MOVE BCT-VALUT  TO VALUT.
           MOVE BCT-ACCON  TO ACCON.
           MOVE FAT-TOTFT  TO TOTFAT.
           MOVE AFT-PROG   TO PRGXML.
           IF AFT-PROG = '00000'
              MOVE SPACE TO PRGXML.
      *
           MOVE BCT-DSFAT  TO DSFAT.
      *
           IF AFT-IPA = SPACE
              MOVE AFT-DEST TO IPADEST
              IF AFT-DEST = '0000000'
                 MOVE SPACE TO IPADEST
              END-IF 
           ELSE
              MOVE AFT-IPA  TO IPADEST.
           IF IPADEST = SPACE
              IF SPS-CODICEUFFI = SPACE
                 MOVE SPS-CODICEDEST TO IPADEST
              ELSE
                 MOVE SPS-CODICEUFFI TO IPADEST.
      *
           IF AFT-CIG = SPACE
              MOVE SPS-CIG  TO CIG
           ELSE
              MOVE AFT-CIG  TO CIG.
      *
           IF AFT-CUP = SPACE
              MOVE SPS-CUP  TO CUP
           ELSE
              MOVE AFT-CUP  TO CUP.
      *
           IF AFT-FAORD = SPACE
              MOVE SPS-FAORD  TO FAORD
           ELSE
              MOVE AFT-FAORD  TO FAORD.
      *
           IF AFT-FADTORD = ZERO
              MOVE SPS-FADTORD  TO AAGGG
           ELSE
              MOVE AFT-FADTORD  TO AAGGG.
      *
           MOVE AFT-PEC   TO PEC.
           IF AFT-PEC = SPACE OR
              AFT-PEC = ALL '0'
              MOVE SPS-PEC  TO PEC
           ELSE
              MOVE AFT-PEC  TO PEC.
      *
           MOVE AFT-TIPOD TO TIPOD.
           IF AFT-TIPOD = SPACE OR
              AFT-TIPOD = '0000'
              IF KFT-TDOC NOT = 3 AND
                 KFT-TDOC NOT = 6
                 IF AFT-TIPO = ZERO
                    MOVE 'TD01' TO TIPOD
                 ELSE
                    IF AFT-TIPO = 1
                       MOVE 'TD05' TO TIPOD
                    ELSE
                       MOVE 'TD02' TO TIPOD
                    END-IF
                 END-IF
              ELSE
                 MOVE 'TD04' TO TIPOD.
      *
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO FADTORD.
      *
           MOVE LF         TO LF1.
      *
           PERFORM CARICA-LVIEW THRU EX-CARICA-LVIEW.
       MOVE-END.
           EXIT.
           MOVE KFT-TDOC TO TABKTDOC(NR).
           MOVE KFT-NUM  TO TABKNFAT(NR).
           MOVE BCT-TDOC TO TKTDOC(NR).
           MOVE BCT-TMODU TO TKTMODU(NR).
           ADD 1 TO LETTI.
           IF FUN = 'T' OR 'L'
              MOVE NR TO KMIN
           ELSE
              MOVE NR TO KMAX.
      *
           ADD 1 TO NR.
       EX-MOVE-REC.
           EXIT.
      *------------------
       CONTROLLA-FILTRI.
           MOVE ZERO TO FLGOK.
      *    IF KBC-NUM NOT = GS-FAT-TNUM GO TO EX-CONTROLLA-FILTRI.
           IF KBC-AZI NOT = GS-AZI  GO TO EX-CONTROLLA-FILTRI.
      *    IF GS-FAT-BOFA NOT = 'B'
              IF FAT-CATT NOT = GS-FAT-CATT GO TO EX-CONTROLLA-FILTRI.
      *
           MOVE RX-FAT-F-DAT-1 TO GGMMAA.
           MOVE 1              TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF FAT-DATA < AAGGG GO TO EX-CONTROLLA-FILTRI.
           MOVE RX-FAT-F-DAT-2 TO GGMMAA.
           MOVE 1              TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AAGGG NOT = ZERO  
              IF FAT-DATA > AAGGG GO TO EX-CONTROLLA-FILTRI.
      *
           IF RX-FAT-F-AGE NOT = ZERO
              IF RX-FAT-F-AGE NOT = BCT-CAGE GO TO EX-CONTROLLA-FILTRI.
      *
           IF RX-FAT-F-CLI NOT = ZERO
              IF RX-FAT-F-CLI NOT = FAT-CDCLI GO TO EX-CONTROLLA-FILTRI.
      *
           IF RX-FAT-F-XML-0 = ZERO
              IF AFT-XML = ZERO OR SPACE OR LOW-VALUE
                 GO TO EX-CONTROLLA-FILTRI.
           IF RX-FAT-F-XML-1 = ZERO
              IF AFT-XML = 1
                 GO TO EX-CONTROLLA-FILTRI.
           IF RX-FAT-F-XML-2 = ZERO
              IF AFT-XML = 2
                 GO TO EX-CONTROLLA-FILTRI.
           IF RX-FAT-F-XML-3 = ZERO
              IF AFT-XML = 3
                 GO TO EX-CONTROLLA-FILTRI.
           IF RX-FAT-F-XML-4 = ZERO
              IF AFT-XML = 4
                 GO TO EX-CONTROLLA-FILTRI.
           IF RX-FAT-F-XML-5 = ZERO
              IF AFT-XML = 5
                 GO TO EX-CONTROLLA-FILTRI.
           IF RX-FAT-F-XML-8 = ZERO
              IF AFT-XML = 8
                 GO TO EX-CONTROLLA-FILTRI.
           IF RX-FAT-F-XML-9 = ZERO
              IF AFT-XML = 9
                 GO TO EX-CONTROLLA-FILTRI.
      *
           IF RX-FAT-F-ZON NOT = SPACE
              IF RX-FAT-F-ZON NOT = BCT-ZONA GO TO EX-CONTROLLA-FILTRI.
      *
           MOVE AFT-TIPOD TO COMTIPO.
           IF AFT-TIPOD = SPACE
              IF KFT-TDOC NOT = 3 AND
                 KFT-TDOC NOT = 6
                 IF AFT-TIPO = ZERO
                    MOVE 'TD01' TO COMTIPO
                 ELSE
                    IF AFT-TIPO = 1
                       MOVE 'TD05' TO COMTIPO
                    ELSE
                       MOVE 'TD02' TO COMTIPO
                    END-IF
                 END-IF
              ELSE
                 MOVE 'TD04' TO COMTIPO.
      *
           IF RX-FAT-F-TIPOD NOT = SPACE
              IF RX-FAT-F-TIPOD NOT = COMTIPO 
                 GO TO EX-CONTROLLA-FILTRI.
      *
      *>
           MOVE 1 TO FLGOK.
       EX-CONTROLLA-FILTRI.
           EXIT.
      *------------------
       VER-LPD.
           MOVE ZERO TO PLPD-PROG.
           IF PINT-AZI = ZERO GO TO EX-VER-LPD.
      *
           MOVE 'R'     TO PLPD-FUN.
           MOVE KBC-AZI TO PLPD-AZI.
           IF PINT-I-AZI NOT = SPACE
              MOVE PINT-I-AZI TO PLPD-AZI.
           MOVE 'INT'   TO PLPD-TIPO.
      *
           MOVE BCT-DATA  TO AAGGG.
           MOVE 2 TO TIPOP1
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO PLPD-ANNO.
      *
           IF PLPD-TDOC = 'BOL' OR 'BFT'
                MOVE KEYBC TO PLPD-KEY
           ELSE MOVE SPACE       TO PLPD-KEY
                MOVE KBC-AZI     TO PLPD-KEY(1:3)
                IF BCT-TDOC = 8 OR 9
                   MOVE BCT-TDOC TO PLPD-KEY(4:1)
                   MOVE KBC-BOL  TO NUFAT
                   MOVE XNUFAT   TO PLPD-KEY(5:)
                ELSE
                   MOVE BCT-KFATT TO PLPD-KEY(4:).
      *
           MOVE BCT-CATT    TO PLPD-CATT.
           CALL 'vrc-lpd' USING PARXCD PARLPD.
       EX-VER-LPD.
           EXIT.
      *------------------
       UPDATE-ITEM.
           MOVE LVITEM-TEXT(2)   TO NRIGAX.
           MOVE NRIGA            TO RX-POS FOCUSNR.
           MOVE LV-NUMERIC-VALUE TO PGZ-POSLV.
           PERFORM CONTROLLA-POS.
      *
           MOVE GS-FAT-CATT TO FATTIV.
           IF FATTIV = '0' MOVE SPACE TO FATTIV.
           PERFORM CHECK-FATTUR THRU EX-CHECK-FATTUR.
           IF CHECK = 1
              MOVE 'Fatture inesistenti su attivit' TO F-MES1
              MOVE 'selezionata.                   ' TO F-MES2
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO FINE.
           OPEN INPUT BOLCTE SPESOG ANACLF FATTUR APPFAT.
           MOVE GS-AZI           TO KFT-AZI.
           MOVE TABKTDOC(RX-POS) TO KFT-TDOC.
           MOVE TABKNFAT(RX-POS) TO KFT-NUM.
           READ FATTUR INVALID PERFORM INVK-FAT
                            GO TO ERRIO.
      *
           MOVE KFT-AZI  TO KAFT-AZI.
           MOVE KFT-TDOC TO KAFT-TDOC.
           MOVE KFT-NUM  TO KAFT-NUM.
           MOVE FAT-CATT TO KAFT-CATT.
           READ APPFAT INVALID
                PERFORM AZZ-AFT THRU EX-AZZ-AFT.
      *
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-NBOL(1) TO KBC-BOL.
           MOVE RB-TNUM(1) TO KBC-NUM.
           READ BOLCTE INVALID PERFORM INVK-BCT
                            GO TO ERRIO.
      *
           MOVE NR            TO SAVNR.
           MOVE PGZ-POSLV     TO LV-NUMERIC-VALUE.
           MOVE FOCUSNR       TO NR.
           PERFORM MOVE-REC THRU MOVE-END.
           CLOSE BOLCTE SPESOG ANACLF FATTUR APPFAT.
           MOVE SAVNR         TO NR.
       EX-UPDATE-ITEM.
           EXIT.
      *------------------
       INSERT-ITEM.
           MOVE GS-FAT-CATT TO FATTIV.
           IF FATTIV = '0' MOVE SPACE TO FATTIV.
           PERFORM CHECK-FATTUR THRU EX-CHECK-FATTUR.
           IF CHECK = 1
              MOVE 'Fatture inesistenti su attivit' TO F-MES1
              MOVE 'selezionata.                   ' TO F-MES2
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO FINE.
           OPEN INPUT BOLCTE SPESOG ANACLF FATTUR APPFAT.
           MOVE GS-AZI          TO KFT-AZI.
           MOVE GS-FAT-COD-TDOC TO KFT-TDOC.
           MOVE GS-FAT-COD-NFAT TO KFT-NUM.
           READ FATTUR INVALID PERFORM INVK-FAT
                       GO TO ERRIO.
      *
           MOVE KFT-AZI  TO KAFT-AZI.
           MOVE KFT-TDOC TO KAFT-TDOC.
           MOVE KFT-NUM  TO KAFT-NUM.
           MOVE FAT-CATT TO KAFT-CATT.
           READ APPFAT INVALID
                PERFORM AZZ-AFT THRU EX-AZZ-AFT.
      *
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-NBOL(1) TO KBC-BOL.
           MOVE RB-TNUM(1) TO KBC-NUM.
           READ BOLCTE INVALID PERFORM INVK-BCT
                            GO TO ERRIO.
      *
           MOVE NR TO SAVNR.
      *
           MOVE 'D'       TO LVITEM-DOVE.
           PERFORM MOVE-REC THRU EX-MOVE-REC.
           CLOSE BOLCTE SPESOG ANACLF FATTUR APPFAT.
           IF NR = SAVNR GO TO EX-INSERT-ITEM.
      *
           MOVE NR TO FOCUSNR.
           SUBTRACT 1 FROM FOCUSNR.
      *
           ADD 1 TO RX-LETTI.
      *
      * sort
           MOVE GS-AZI     TO PGZ-AZI.
           MOVE 'S'        TO PGZ-FUN.
           MOVE NPGMZOOM   TO PGZ-ZOOM.
           MOVE NPGMLVIEW  TO PGZ-NPGM.
           MOVE SPACE      TO PGZ-DATI.
           CALL 'vrgenzom' USING PARGZOOM IF-MESS Data-Block.
      *
           PERFORM SET-FOCUS THRU EX-SET-FOCUS.
       EX-INSERT-ITEM.
           EXIT.
      *------------------
       V-DATI.
      * validazione dei campi filtri
           MOVE ZERO TO VFLD.
      *
       V-PER.
           MOVE 'PER' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = RX-CAMPO GO TO E-PER.
      *
           MOVE RX-FAT-F-PER TO TIPPER.
           CALL 'rperiod' USING PARPER.
           MOVE GGMMAA-1 TO RX-FAT-F-DAT-1.
           MOVE GGMMAA-2 TO RX-FAT-F-DAT-2.
      *
       E-PER.
      *
       V-DAT-1.
           MOVE 'DAT-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = RX-CAMPO GO TO E-DAT-1.
           MOVE 1 TO TIPOP1.
           MOVE RX-FAT-F-DAT-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DAT1.
       E-DAT-1.
      *
       V-DAT-2.
           MOVE 'DAT-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = RX-CAMPO GO TO E-DAT-2.
           MOVE 1 TO TIPOP1.
           MOVE RX-FAT-F-DAT-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DAT2.
           IF DAT1 > DAT2 
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DAT-2.
      *
           GO TO EX-V-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
       INIZIA-ZOOM.
           MOVE 1 TO LV-ICONSWANTED.
           PERFORM CREA-LVIEW THRU EX-CREA-LVIEW.
      *
           MOVE ZERO  TO RX-FAT-FILTRI.
           MOVE SPACE TO RX-FAT-F-ZON.
           MOVE SPACE TO RX-FAT-F-TIPOD.
           MOVE 1 TO RX-FAT-F-XML-0.
           MOVE 1 TO RX-FAT-F-XML-1.
           MOVE 1 TO RX-FAT-F-XML-2.
           MOVE 1 TO RX-FAT-F-XML-3.
           MOVE 1 TO RX-FAT-F-XML-4.
           MOVE 1 TO RX-FAT-F-XML-5.
           MOVE 1 TO RX-FAT-F-XML-8.
           MOVE 1 TO RX-FAT-F-XML-9.
           IF GS-SV   = ZERO     GO TO EX-INIZIA-ZOOM.
           IF PGZ-ST  NOT = ZERO GO TO EX-INIZIA-ZOOM.
      *
           MOVE PGZ-FILT(1)(1:1)  TO GS-FUN.
           MOVE PGZ-FILT(2)(1:1)  TO GS-IDX.
           IF PGZ-FILT(3)(1:5) NOT = ZERO
           MOVE PGZ-FILT(3)(1:1)  TO GS-FAT-VAL-1-TDOC.
           MOVE PGZ-FILT(4)(1:5)  TO GS-FAT-VAL-1-NFAT.
      *
           MOVE PGZ-FILT(6)(1:1)  TO RX-FAT-F-PER.
           MOVE PGZ-FILT(7)(1:6)  TO RX-FAT-F-DAT-1.
           MOVE PGZ-FILT(8)(1:6)  TO RX-FAT-F-DAT-2.
           MOVE PGZ-FILT(9)(1:3)  TO RX-FAT-F-AGE.
           MOVE PGZ-FILT(10)(1:3) TO RX-FAT-F-ZON.
           MOVE PGZ-FILT(11)(1:1) TO RX-FAT-F-XML-0.
           MOVE PGZ-FILT(12)(1:1) TO RX-FAT-F-XML-1.
           MOVE PGZ-FILT(13)(1:1) TO RX-FAT-F-XML-2.
           MOVE PGZ-FILT(14)(1:1) TO RX-FAT-F-XML-3.
           MOVE PGZ-FILT(15)(1:1) TO RX-FAT-F-XML-4.
           MOVE PGZ-FILT(16)(1:1) TO RX-FAT-F-XML-5.
           MOVE PGZ-FILT(17)(1:1) TO RX-FAT-F-XML-8.
           MOVE PGZ-FILT(18)(1:1) TO RX-FAT-F-XML-9.
           MOVE PGZ-FILT(19)(1:5) TO RX-FAT-F-CLI.
           MOVE PGZ-FILT(20)(1:4) TO RX-FAT-F-TIPOD.
      *
           IF RX-FAT-F-PER > ZERO
              MOVE RX-FAT-F-PER TO TIPPER
              CALL 'rperiod' USING PARPER
              MOVE GGMMAA-1 TO RX-FAT-F-DAT-1
              MOVE GGMMAA-2 TO RX-FAT-F-DAT-2.
       EX-INIZIA-ZOOM.
           EXIT.
      *------------------
      * eventuali dati da aggiornare a seguito cancellazione/inserimento
      * /modifica
      * es. totale documento
       AGG-PIEDE.
       EX-AGG-PIEDE.
           EXIT.
      *------------------
       SAVE-OPZI.
           MOVE GS-FUN         TO PGZ-FILT(1)(1:1).
           MOVE GS-IDX         TO PGZ-FILT(2)(1:1).
           MOVE GS-FAT-VAL-1-TDOC TO PGZ-FILT(3)(1:1).
           MOVE GS-FAT-VAL-1-NFAT TO PGZ-FILT(4)(1:5).
      *
           MOVE RX-FAT-F-PER   TO PGZ-FILT(6)(1:1).
           MOVE RX-FAT-F-DAT-1 TO PGZ-FILT(7)(1:6).
           MOVE RX-FAT-F-DAT-2 TO PGZ-FILT(8)(1:6).
           MOVE RX-FAT-F-AGE   TO PGZ-FILT(9)(1:3).
           MOVE RX-FAT-F-ZON   TO PGZ-FILT(10)(1:3).
           MOVE RX-FAT-F-XML-0 TO PGZ-FILT(11)(1:1).
           MOVE RX-FAT-F-XML-1 TO PGZ-FILT(12)(1:1).
           MOVE RX-FAT-F-XML-2 TO PGZ-FILT(13)(1:1).
           MOVE RX-FAT-F-XML-3 TO PGZ-FILT(14)(1:1).
           MOVE RX-FAT-F-XML-4 TO PGZ-FILT(15)(1:1).
           MOVE RX-FAT-F-XML-5 TO PGZ-FILT(16)(1:1).
           MOVE RX-FAT-F-XML-8 TO PGZ-FILT(17)(1:1).
           MOVE RX-FAT-F-XML-9 TO PGZ-FILT(18)(1:1).
           MOVE RX-FAT-F-CLI   TO PGZ-FILT(19)(1:5).
           MOVE RX-FAT-F-TIPOD TO PGZ-FILT(20)(1:4).
      *
           MOVE GS-AZI     TO PGZ-AZI.
           MOVE 'o'        TO PGZ-FUN.
           MOVE NPGMZOOM   TO PGZ-ZOOM.
           MOVE NPGMLVIEW  TO PGZ-NPGM.
           MOVE SPACE      TO PGZ-DATI.
           CALL 'vrgenzom' USING PARGZOOM IF-MESS Data-Block.
       EX-SAVE-OPZI.
           EXIT.
      *------------------
       CHECK-FATTUR.
           MOVE ZERO TO CHECK.
           MOVE ID-FAT TO FILE-NAME
           CALL "CBL_CHECK_FILE_EXIST" USING FILE-NAME
                                             FILE-DETAILS
                                  RETURNING STATUS-CODE
           IF STATUS-CODE NOT = ZERO
              MOVE 1 TO CHECK.
       EX-CHECK-FATTUR.
           EXIT.
      *------------------
       AZZ-AFT.
           MOVE ZERO TO RF-AFT.
           MOVE SPACE TO AFT-IPA.
           MOVE SPACE TO AFT-CIG.
           MOVE SPACE TO AFT-CUP.
           MOVE SPACE TO AFT-FAORD.
           MOVE SPACE TO AFT-TIPOD.
           MOVE SPACE TO AFT-DEST.
           MOVE SPACE TO AFT-PEC.
       EX-AZZ-AFT.
           EXIT.
      *------------------
