      $SET LINKCOUNT"128"
       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRGSPS.
      *
      *    Interfaccia SPESOG per scheda
      *
      **** rel 7.2
      * Nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griclfsl'.
           COPY 'grispssl'.
           COPY 'grisstsl'.
           COPY 'griazisl'.
           COPY 'gritabsl'.
           COPY 'griacfsl'.
      **** rel 7.2
           COPY 'gribktsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griclf'.
           COPY 'grisps'.
           COPY 'grisst'.
           COPY 'griazi'.
           COPY 'gritab'.
           COPY 'griacf'.
      **** rel 7.2
           COPY 'gribkt'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'griazirk'.
      *    COPY 'grisstrk'.
      **** rel 7.2
           COPY 'gribktrk'.
      ************
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'prfisc'.
           COPY 'prpiva'.
           COPY 'parer'.
           COPY 'parml'.
           COPY 'parppar'.
           COPY 'parmb'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-SPS PIC X(15) VALUE 'spesog'.
       01  ID-SST PIC X(15) VALUE 'spetab'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-ACF PIC X(15) VALUE 'appclf'.
      **** rel 7.2
       01  ID-BKT PIC X(15) VALUE 'blktab'.
      ************
      *---------------------------------------------------
      * costanti
      *    NRIGMAX: n. righe max note cliente
       78  NRIGMAX  VALUE 20.
      *---------------------------------------------------
       01  COMODI.
           05 SF-CLF PIC XX.
           05 SF-SPS PIC XX.
           05 SF-SST PIC XX.
           05 SF-AZI PIC XX.
           05 SF-TAB PIC XX.
           05 SF-ACF PIC XX.
      **** rel 7.2
           05 SF-BKT PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(30).
           05 IF-AZI   PIC 9(3).
           05 IF-MS    PIC 99.
           05 IF-CLFO  PIC X.
           05 COMPAE.
              10 CPAE PIC XX.
              10 CIVE PIC X(12).
              10 CABB PIC XX.
           05 SAVKEY.
              10 SAZI PIC 999.
              10 SCOD.
                 15 SVMAS PIC 99.
                 15 SVCOD PIC 9(5).
           05 COMCOD.
              10 COMMAS PIC 99.
              10 FILLER PIC X(5).
           05 CLAV    PIC S9(14)V99.
           05 COMCFISC.
              10 COMCFP  PIC X(11) VALUE SPACE.
              10 COMBLK  PIC X(5)  VALUE SPACE.
           05 FLAG-CFISC   PIC 9.
           05 FLAG-PIVA    PIC 9.
           05 FLAG-PIVADOP PIC 9.
           05 FLAG-CATCON  PIC 9.
           05 CODU         PIC 9(5) VALUE ZERO.
           05 OLDGRU       PIC X(3).
           05 CLFIVA       PIC 9(7) VALUE ZERO.
           05 SWINS        PIC 9.
           05 KML      PIC 9(5).
           05 KVALID   PIC 9(5).
           05 KN       PIC 9(5).
           05 MAXRIGD  PIC ZZ9.
           05 K        PIC 99.
           05 J        PIC 99.
           05 FLGNEW   PIC 9.
           05 SKEYCF   PIC X(10).
      *
           05 VETMES  PIC X(12) VALUE 'ABCDEHLMPRST'.
           05 NUMMES  REDEFINES VETMES PIC X OCCURS 12.
           05 CDFISC  PIC X(16).
           05 DTFISC  REDEFINES CDFISC.
              10 FILLER PIC X(6).
              10 AN     PIC XX.
              10 ANM REDEFINES AN PIC 99.
              10 MS     PIC X.
              10 GI     PIC XX.
              10 GIM REDEFINES GI PIC 99.
              10 FILLER PIC X(5).
           05 DTFIVA  REDEFINES CDFISC.
              10 NUM    PIC X(11).
              10 BLK    PIC X(5).
      *
       LINKAGE SECTION.
           COPY 'grispsrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-SPS-CTRL
                                RG-SPS-REC
                                RA-SPS-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclclf'.
           COPY 'dclsps'.
           COPY 'dclsst'.
           COPY 'dclazi'.
           COPY 'dcltab'.
           COPY 'dclacf'.
      **** rel 7.2
           COPY 'dclbkt'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-SPS-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-SPS-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-SPS-FUN   TO FUN.
           MOVE RG-SPS-IDX   TO IDX.
           MOVE RG-SPS-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-SPS-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vrgSPS: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-SPS-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           MOVE 1 TO SWINS.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-SPS-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-SPS-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK ANACLF.
           UNLOCK SPESOG.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           IF SPS-MODIFICATO = ZERO
              GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-SPS INVALID
              PERFORM VISK-CLF
              PERFORM INVK-SPS
              GO TO ERRIO.
      *
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           IF SPS-MODIFICATO = ZERO
              GO TO F-DELETE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-SPS INVALID
             REWRITE RF-SPS INVALID
              PERFORM VISK-CLF
              PERFORM INVK-SPS
              GO TO ERRIO.
           UNLOCK ANACLF.
           UNLOCK SPESOG.
      *
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           MOVE KEYCF TO KEYSPS.
           READ SPESOG INVALID
              MOVE 'Dati spesometro inesistenti su soggetto' TO MESS
              GO TO WARNING.
           IF VKEY > ZERO
              PERFORM VISK-CLF
              PERFORM INVK-SPS
              GO TO WARNING.
           IF RG-SPS-ST = 7 GO TO FINE.
      *
           PERFORM DB-STORNA THRU EX-DB-STORNA.
      *
           DELETE SPESOG INVALID
              PERFORM VISK-CLF
              PERFORM INVK-SPS
              GO TO ERRIO.
           UNLOCK ANACLF.
      *
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-SPS-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK ANACLF.
           UNLOCK SPESOG.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-SPS-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANACLF.
           CLOSE SPESOG.
           CLOSE SPETAB.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE APPCLF.
      **** rel 7.2
           CLOSE BLKTAB.
      ************
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-SPS-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-SPS-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griclfer'.
           COPY 'grispser'.
           COPY 'grisster'.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'griacfer'.
      **** rel 7.2
           COPY 'gribkter'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           MOVE 'anaazi' TO ID-AZI.
           MOVE 'tabell' TO ID-TAB.
      *
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT SPETAB.
           OPEN INPUT APPCLF.
      **** rel 7.2
           OPEN INPUT BLKTAB.
      ************
           OPEN I-O ANACLF.
           OPEN I-O SPESOG.
      *
           MOVE RG-SPS-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID
                PERFORM INVK-AZI
                GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF RG-SPS-CLFO = 'F'
              MOVE T01-MFOR TO RG-SPS-MS
           ELSE
              MOVE T01-MCLI TO RG-SPS-MS.
           MOVE ZERO TO SWINS.
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-SPS-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO TO RF-SPS.
      *
           MOVE SPACE TO SPS-COGNOME SPS-NOME SPS-PIVA SPS-CFISC
                         SPS-STAB-INDIR SPS-STAB-INDIR2 SPS-STAB-CIT 
                         SPS-STAB-PRV SPS-STAB-NAZ SPS-RAPR-PAESE 
                         SPS-RAPR-IDFISC SPS-RAPR-DENOM SPS-RAPR-COGNOME
                         SPS-RAPR-NOME.
           MOVE SPACE TO SPS-NAZIONE.
      **** rel 7.2
           MOVE SPACE TO SPS-CODICEUFFI.
           MOVE SPACE TO SPS-CODICEDEST.
           MOVE SPACE TO SPS-PEC.
           MOVE SPACE TO SPS-CIG.
           MOVE SPACE TO SPS-CUP.
           MOVE SPACE TO SPS-FAORD.
           MOVE SPACE TO SPS-RIFAMM.
           MOVE ZERO  TO SPS-FADTORD.
      ************
      *
           MOVE 1 TO SPS-FLGBSE.
      *
           IF CLF-PIVA NOT = ZERO
              MOVE CLF-PIVA  TO SPS-PIVA.
           MOVE CLF-CFISC TO SPS-CFISC.
           IF CLF-13IVA = 4
              IF CLF-PAE NOT = SPACE AND
                 CLF-PAE NOT = 'IT' AND
                 CLF-PAE IS NOT NUMERIC
                 MOVE CLF-CFISC TO COMFISC
                 CALL 'rfisc' USING PARFISC
                 IF RISPFISC NOT = ZERO
                    MOVE SPACE     TO SPS-CFISC
                    MOVE CLF-IVE   TO SPS-PIVA. 
           IF CLF-13IVA = 4 AND CLF-PAE = 'IT' AND
              CLF-IVE(1:11) IS NUMERIC AND CLF-IVE(12:) = SPACE
              MOVE SPACE     TO SPS-CFISC
              MOVE CLF-IVE   TO SPS-PIVA. 
      *
           MOVE ACF-NAZIO TO SPS-NAZIONE.
      *
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-SPS-AZI  TO IF-AZI.
           MOVE RG-SPS-MS   TO IF-MS.
           MOVE RG-SPS-CLFO TO IF-CLFO.
      *
      * azzeramento aree interfaccia
           MOVE ZERO  TO RG-SPS-REC.
           MOVE SPACE TO RG-SPS-PIVA RG-SPS-CFISC.
           MOVE SPACE TO RG-SPS-STAB-INDIR RG-SPS-STAB-INDIR2
                         RG-SPS-STAB-CIT RG-SPS-STAB-PRV RG-SPS-STAB-NAZ
                         RG-SPS-RAPR-PAESE RG-SPS-RAPR-IDFISC 
                         RG-SPS-RAPR-DENOM RG-SPS-RAPR-COGNOME 
                         RG-SPS-RAPR-NOME.
      **** rel 7.2
           MOVE SPACE TO RG-SPS-CODICEUFFI.
           MOVE SPACE TO RG-SPS-CODICEDEST.
           MOVE SPACE TO RG-SPS-PEC.
           MOVE SPACE TO RG-SPS-CIG.
           MOVE SPACE TO RG-SPS-CUP.
           MOVE SPACE TO RG-SPS-FAORD.
           MOVE SPACE TO RG-SPS-RIFAMM.
           MOVE ZERO  TO RG-SPS-FADTORD.
      ************
      *
           MOVE ZERO  TO RA-SPS-AGG.
           MOVE SPACE TO RA-SPS-NOTE.
           MOVE SPACE TO RG-SPS-NAZIONE.
      **** rel 7.2
           MOVE SPACE TO RA-SPS-NAZIONE-D.
      ************
      *
           MOVE IF-AZI  TO RG-SPS-AZI.
           MOVE IF-MS   TO RG-SPS-MS.
           MOVE IF-CLFO TO RG-SPS-CLFO.
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
           MOVE 1         TO RG-SPS-FLGBSE.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-SPS-AZI TO KCF-AZI.
           MOVE RG-SPS-CD TO CLF-CD.
           MOVE RG-SPS-MS TO CLF-MS.
           MOVE CLF-COD   TO KCF-COD.
           MOVE KEYCF TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYCF.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ ANACLF INTO REKCLF INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE KEYCF TO KEYACF.
           READ APPCLF.
           MOVE KEYCF TO KEYSPS.
           READ SPESOG INVALID
             PERFORM AZZ-REC THRU EX-AZZ-REC.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ ANACLF INTO REKCLF KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-CLF > ZERO MOVE 7 TO RG-SPS-ST.
           MOVE KEYCF TO KEYACF.
           READ APPCLF.
           MOVE KEYCF TO KEYSPS.
           READ SPESOG KEPT LOCK INVALID
             PERFORM AZZ-REC THRU EX-AZZ-REC.
      *
       EX-READ-K.
           EXIT.
      *------------------
      * posizionamento su chiave secondaria per successive
      * read next/previous
      *
       SET-KEYSEC.
           MOVE KEYCF TO KRIFER.
           IF IDX = 2
              START ANACLF KEY >= KEYCFS INVALID GO TO SET-90
           ELSE
              START ANACLF KEY >= KEYCF2 INVALID GO TO SET-90.
       SET-10.
           READ ANACLF NEXT INTO REKCLF AT END GO TO SET-90.
           MOVE KEYCF TO KEYACF.
           READ APPCLF.
           MOVE KEYCF TO KEYSPS.
           READ SPESOG KEPT LOCK INVALID
             PERFORM AZZ-REC THRU EX-AZZ-REC.
      *
           IF KEYCF = KRIFER GO TO EX-SET-KEYSEC.
           GO TO SET-10.
       SET-90.
           MOVE 'vrgSPS: errore di posizionamento su' TO F-MES1.
           MOVE 'chiave secondaria'                   TO F-MES2.
           MOVE 2 TO F-NMES.
           GO TO ERRIO.
       EX-SET-KEYSEC.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
           IF IDX > 1 PERFORM SET-KEYSEC THRU EX-SET-KEYSEC.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ ANACLF PREVIOUS INTO REKCLF AT END MOVE 1 TO EOF
           ELSE
              READ ANACLF NEXT INTO REKCLF AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           MOVE KEYCF TO KEYACF.
           READ APPCLF.
           MOVE KEYCF TO KEYSPS.
           READ SPESOG KEPT LOCK INVALID
             PERFORM AZZ-REC THRU EX-AZZ-REC.
      *
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-CLF = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *
           IF KCF-AZI NOT = RG-SPS-AZI GO TO RNP-10.
           IF CLF-MS  NOT = RG-SPS-MS  GO TO RNP-10.

           IF RG-SPS-SOLOBLK NOT = ZERO
              MOVE KEYCF TO KEYSPS
              READ SPESOG INVALID GO TO RNP-10.

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-SPS-EOF.
           MOVE KEYCF TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-SPS-EOF.
           IF RG-SPS-EOF = 4 MOVE 2 TO RG-SPS-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-CLF = LOW-VALUE GO TO EX-TEST-EOL.
           IF IDX > 1 GO TO TEST-EOL-IDX2.
           IF KCF-AZI = RG-SPS-AZI AND
              CLF-MS  = RG-SPS-MS  GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       TEST-EOL-IDX2.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-SPS-AZI       TO KSPS-AZI.
           MOVE RG-SPS-MS        TO KSPS-MS.
           MOVE RG-SPS-CD        TO KSPS-CD.
           MOVE RG-SPS-FLGBSE    TO SPS-FLGBSE.
           MOVE RG-SPS-COGNOME   TO SPS-COGNOME.
           MOVE RG-SPS-NOME      TO SPS-NOME.
           MOVE RG-SPS-CFISC     TO SPS-CFISC.
           MOVE RG-SPS-PIVA      TO SPS-PIVA.
      *
           MOVE RG-SPS-STAB-INDIR   TO SPS-STAB-INDIR.
           MOVE RG-SPS-STAB-INDIR2  TO SPS-STAB-INDIR2.
           MOVE RG-SPS-STAB-CAP     TO SPS-STAB-CAP.
           MOVE RG-SPS-STAB-CIT     TO SPS-STAB-CIT.
           MOVE RG-SPS-STAB-PRV     TO SPS-STAB-PRV.
           MOVE RG-SPS-STAB-NAZ     TO SPS-STAB-NAZ.
           MOVE RG-SPS-RAPR-PAESE   TO SPS-RAPR-PAESE. 
           MOVE RG-SPS-RAPR-IDFISC  TO SPS-RAPR-IDFISC.
           MOVE RG-SPS-RAPR-DENOM   TO SPS-RAPR-DENOM.
           MOVE RG-SPS-RAPR-COGNOME TO SPS-RAPR-COGNOME.
           MOVE RG-SPS-RAPR-NOME    TO SPS-RAPR-NOME.
           MOVE RG-SPS-DISABILITA   TO SPS-DISABILITA.
           MOVE RG-SPS-NAZIONE      TO SPS-NAZIONE.
           MOVE RG-SPS-RIEPI        TO SPS-RIEPI.
           MOVE RG-SPS-MODIFICATO   TO SPS-MODIFICATO.
           MOVE RG-SPS-RIFAMM       TO SPS-RIFAMM.
      **** rel 7.2
           MOVE RG-SPS-CODICEUFFI   TO SPS-CODICEUFFI.
           MOVE RG-SPS-CODICEDEST   TO SPS-CODICEDEST.
           MOVE RG-SPS-PEC          TO SPS-PEC.
           MOVE RG-SPS-CIG          TO SPS-CIG.
           MOVE RG-SPS-CUP          TO SPS-CUP.
           MOVE RG-SPS-FAORD        TO SPS-FAORD.
           MOVE RG-SPS-FADTORD TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG               TO SPS-FADTORD.
      ************
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE CLF-AZI       TO RG-SPS-AZI.
           MOVE CLF-MS        TO RG-SPS-MS.
           MOVE CLF-CD        TO RG-SPS-CD.
           MOVE CLF-RGSOC     TO RG-SPS-RGSOC.
           MOVE CLF-RGSOC2    TO RG-SPS-RGSOC2.
           MOVE CLF-INDIR     TO RG-SPS-INDIR.
           MOVE CLF-INDIR2    TO RG-SPS-INDIR2.
           MOVE CLF-CAP       TO RG-SPS-CAP.
           MOVE CLF-CIT       TO RG-SPS-CIT.
           MOVE CLF-PRV       TO RG-SPS-APRV.
      *
           MOVE SPS-FLGBSE    TO RG-SPS-FLGBSE.
           MOVE SPS-COGNOME   TO RG-SPS-COGNOME.
           MOVE SPS-NOME      TO RG-SPS-NOME.
           MOVE SPS-CFISC     TO RG-SPS-CFISC.
           MOVE SPS-PIVA      TO RG-SPS-PIVA.
      *
           MOVE SPS-STAB-INDIR   TO RG-SPS-STAB-INDIR.
           MOVE SPS-STAB-INDIR2  TO RG-SPS-STAB-INDIR2.
           MOVE SPS-STAB-CAP     TO RG-SPS-STAB-CAP.
           MOVE SPS-STAB-CIT     TO RG-SPS-STAB-CIT.
           MOVE SPS-STAB-PRV     TO RG-SPS-STAB-PRV.
           MOVE SPS-STAB-NAZ     TO RG-SPS-STAB-NAZ.
           MOVE SPS-RAPR-PAESE   TO RG-SPS-RAPR-PAESE. 
           MOVE SPS-RAPR-IDFISC  TO RG-SPS-RAPR-IDFISC.
           MOVE SPS-RAPR-DENOM   TO RG-SPS-RAPR-DENOM.
           MOVE SPS-RAPR-COGNOME TO RG-SPS-RAPR-COGNOME.
           MOVE SPS-RAPR-NOME    TO RG-SPS-RAPR-NOME.
           MOVE SPS-DISABILITA   TO RG-SPS-DISABILITA.
           MOVE SPS-NAZIONE      TO RG-SPS-NAZIONE.
           MOVE SPS-RIEPI        TO RG-SPS-RIEPI.
           MOVE SPS-MODIFICATO   TO RG-SPS-MODIFICATO.
           MOVE SPS-RIFAMM       TO RG-SPS-RIFAMM.
      **** rel 7.2
           MOVE SPS-CODICEUFFI   TO RG-SPS-CODICEUFFI.
           MOVE SPS-CODICEDEST   TO RG-SPS-CODICEDEST.
           MOVE SPS-PEC          TO RG-SPS-PEC.
           MOVE SPS-CIG          TO RG-SPS-CIG.
           MOVE SPS-CUP          TO RG-SPS-CUP.
           MOVE SPS-FAORD        TO RG-SPS-FAORD.
           MOVE SPS-FADTORD TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA           TO RG-SPS-FADTORD.
      ************
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
           MOVE 01             TO BKT01-TIP.
           MOVE RG-SPS-NAZIONE TO BKT01-COD.
           MOVE BKT01-KEYID  TO KEYBKT.
           READ BLKTAB INTO REKBKT INVALID
                MOVE SPACE TO BKT01-DESCR.
           MOVE BKT01-DESCR TO RA-SPS-NAZIONE-D. 
       CARICA-RA-20.
      *
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-SPS-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
       V-CD.
           MOVE 'CLF-CD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CD.
           IF RG-SPS-CD = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-CD.
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-SPS-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-CFISC.
           MOVE 'SPS-CFISC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CFISC.
      *
           IF FUN NOT = 'V' GO TO E-CFISC.
      *
           MOVE RG-SPS-CFISC TO CDFISC.
      *
           IF CDFISC = SPACE GO TO E-CFISC.
           IF BLK = SPACE    GO TO E-CFISC.
           IF NOT (AN NUMERIC AND GI NUMERIC) GO TO E-CFISC.
           MOVE ZERO TO K.
       L-CDFISC.
           ADD 1 TO K.
           IF K > 12 GO TO E-CFISC.
           IF MS NOT = NUMMES (K) GO TO L-CDFISC.
      *
       E-CFISC.
      *
      **** rel 7.2
       V-NAZIONE.
           MOVE 'SPS-NAZIONE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NAZIONE.
      *
           IF RG-SPS-NAZIONE = SPACE GO TO E-NAZIONE.
      *
           MOVE 01             TO BKT01-TIP.
           MOVE RG-SPS-NAZIONE TO BKT01-COD.
           MOVE BKT01-KEYID  TO KEYBKT.
           READ BLKTAB INTO REKBKT INVALID
                MOVE SPACE TO RA-SPS-NAZIONE-D 
                PERFORM ERR-CINE
                GO TO V-ERROR.
           MOVE BKT01-DESCR TO RA-SPS-NAZIONE-D. 
       E-NAZIONE.
      *
       V-FADTORD.
           MOVE 'SPS-FADTORD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FADTORD.
      *
           IF RG-SPS-FADTORD = ZERO GO TO E-FADTORD.
      *
           MOVE 1 TO TIPOP1.
           MOVE RG-SPS-FADTORD TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-FADTORD.
      *
      ************
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
